;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; CListe2004 - Color List
;
; Listet die Farbinformation (ACI, RGB oder Farbbuch) von Objekten auf
; auch dann, wenn die Farbe VonLayer lautet
;
; Aufruf: cliste
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 1.6                      Datum: 20.0.52018
; AutoCAD12   [ ]  AutoCAD14   [ ]  AutoCAD2000(i) [ ]
; AutoCAD2002 [ ]  AutoCAD2004 [x]  AutoCAD2005    [x]
; AutoCAD2006 [x]  AutoCAD2007 [x]  AutoCAD2008    [x]
; AutoCAD2009 [x]  AutoCAD2010 [x]  AutoCAD2011    [x]
; AutoCAD2012 [x]  AutoCAD2013 [x]  AutoCAD2014    [x]
; AutoCAD2015 [x]  AutoCAD2016 [x]  AutoCAD2017    [x]
; AutoCAD2018 [x]  AutoCAD2019 [x]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

(defun c:cliste	(/ en ent entLayer entColor entLayerEntity temp1 temp2)
  
  (vl-load-com)
  
  (setq enx (entsel "\nElement whlen"))
  (if (/= enx nil)
    (progn
      (setq en		   (car enx)
	    ent		   (entget en)
	    entLayer	   (cdr (assoc 8 ent))
	    entColor	   (cdr (assoc 62 ent))
	    entLayerEntity (entget (tblobjname "layer" entLayer) '("*"))
      )
      (if (or (= entColor nil) (= entColor 256))
	(setq temp1 "\nDas Element besitzt die Farbe aus dem Layer: "
	      temp2 (clListGetProperty entLayerEntity)
	)
	(setq temp1 "Das Element besitzt eine eigene Farbinformation: "
	      temp2 (clListGetProperty ent)
	)
      )
      (princ (strcat "\n" temp1 temp2))
    )
    (princ "\n")
  )
  (print)
)

(defun clListGetProperty (entList / clTemp cl420 cl430 clRGB clBook)
  (defun clistefarbe (colorinfo)
    (cond ((= colorinfo 1) "rot (1)")
	  ((= colorinfo 2) "gelb (2)")
	  ((= colorinfo 3) "grn (3)")
	  ((= colorinfo 4) "cyan (4)")
	  ((= colorinfo 5) "blau (5)")
	  ((= colorinfo 6) "magenta (6)")
	  ((= colorinfo 7) "wei (7)")
	  ((= colorinfo 8) "dunkelgrau (8)")
	  ((= colorinfo 9) "hellgrau (9)")
	  ((> colorinfo 9) (strcat "Farbe " (itoa colorinfo)))
	  (T nil)
    )
  )

  (setq clTemp (clistefarbe (cdr (assoc 62 entList))))

  (if (setq cl420 (cdr (assoc 420 entList)))(setq clRGB (clGetRGB cl420)))
  (if (setq cl430 (cdr (assoc 430 entList)))(setq clBook (clGetColorBook cl430)))

  (if cl420 (setq clTemp clRGB))
  (if cl430 (setq clTemp (strcat "\nRGB     : " clRGB clBook )))

  clTemp
)

(defun clGetRGB	(clRGB / clRed cl Green clBlue clTemp)
  (setq	clBlue	(logand clRGB 255)
	clGreen	(/ (logand clRGB 65280) 256)
	clRed	(/ (logand clRGB 16711680) 65536)
	clTemp	(strcat	(rtos clRed 2 0) "," (rtos clGreen 2 0)	"," (rtos clBlue 2 0))
  )

  clTemp
)

(defun clGetColorBook (clColorBook / clTemp clI clBookName clColorName)
  (setq	clI	    (vl-string-search "$" clColorBook)
	clBookName  (substr clColorBook 1 clI)
	clColorName (substr clColorBook (+ cli 2))
	clTemp	    (strcat "\nFarbbuch: " clBookName "\nFarbname: " clColorName)
  )

  clTemp
)

(princ "\nCListe2004 - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: cliste")
(print)
